<?xml version="1.0" encoding="UTF-8"?>
<beans:beans xmlns="http://www.springframework.org/schema/integration"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xmlns:beans="http://www.springframework.org/schema/beans"
        xmlns:int-http="http://www.springframework.org/schema/integration/http"
        xsi:schemaLocation="http://www.springframework.org/schema/beans
        http://www.springframework.org/schema/beans/spring-beans.xsd
        http://www.springframework.org/schema/integration/http 
        http://www.springframework.org/schema/integration/http/spring-integration-http.xsd
        http://www.springframework.org/schema/integration
        http://www.springframework.org/schema/integration/spring-integration.xsd">

  <channel id="inputChannel"/>
  <service-activator input-channel="inputChannel"
                     ref="helloService"
                     method="sayHello"/>

  <publish-subscribe-channel id="orderChannel"/>
  <channel id="orderChannelB"/>

  <service-activator input-channel="orderChannel"
                     ref="shippingService"
                     method="handle"/>
  <service-activator input-channel="orderChannel"
                     ref="warehouseService"
                     method="handle"/>

  <beans:bean id="shippingService" class="integration.ShippingService"/>
  <beans:bean id="warehouseService" class="integration.WarehouseService"/>
  <beans:bean id="helloService" class="integration.HelloService"/>

  <channel id="orderreceivechannel" />
  <channel id="orderservicechannel" />
  <channel id="rushorderservicechannel" />

  <payload-type-router input-channel="orderreceivechannel">
    <mapping type="integration.Order" channel="orderservicechannel" />
    <mapping type="integration.RushOrder" channel="rushorderservicechannel" />
  </payload-type-router>

  <header-value-router input-channel="orderreceivechannel"
                       header-name="orderType">
    <mapping value="normal" channel="orderservicechannel" />
    <mapping value="rush" channel="rushorderservicechannel" />

  </header-value-router>

  <service-activator input-channel="orderservicechannel"
                     ref="orderservice" method="handle" />
  <service-activator input-channel="rushorderservicechannel"
                     ref="rushorderservice" method="handle" />

  <beans:bean id="orderservice" class="integration.OrderService" />
  <beans:bean id="rushorderservice" class="integration.RushOrderService" />


</beans:beans>
